// Copyright 2014 Milo Vukov, BSD-style copyright and disclaimer apply

/** Custom errors. */
module Diploma.Core
{
    /** The error that is thrown when a requested method or operation is not implemented. */
    export class NotImplementedError implements Error
    {
        constructor(public message?: string) { }

        public name: string = "NotImplementedError";
    }

    /** The error that is thrown when an invoked method is not supported. */
    export class OperationNotSupportedError implements Error
    {
        constructor(public message?: string) { }

        public name: string = "OperationNotSupportedError";
    }
}