// Copyright 2014 Miloš Vukov, BSD-style copyright and disclaimer apply
var Diploma;
(function (Diploma) {
    (function (Motion) {
        var Core = Diploma.Core;

        /** Activate hyperlink */
        var Navigate = (function () {
            /** Initialize navigate. */
            function Navigate() {
                var _this = this;
                // Initialize debounced execute click.
                this._debouncedExecuteClick = _.debounce(function (gesture, lastHighlightedElement) {
                    this.ExecuteClick(gesture, lastHighlightedElement);
                }, 100, true);

                // Listen to clickable element selected messages.
                Core.EventAggregator.Subscribe(Core.Topics.Core_Pointer_Highlight, function (element) {
                    _this._highlightedElement = $(element);
                });
            }
            /**
            * Intialize navigate.
            * @param controller Initialized LeapMotion controller.
            */
            Navigate.prototype.Initialize = function (controller) {
                var _this = this;
                // Listen to screen tap gesture.
                var taper = controller.gesture('screenTap');
                taper.stop(function (gesture) {
                    _this.Action(gesture);
                });
            };

            /**
            * Execute click on element.
            * @param gesture LeapMotion screen tap gesture.
            */
            Navigate.prototype.Action = function (gesture) {
                if (this.Detected(gesture))
                    this._debouncedExecuteClick(gesture, this._highlightedElement);
            };

            /**
            * Check if gesture is detected.
            * @param gesture LeapMotion screen tap gesture.
            */
            Navigate.prototype.Detected = function (gesture) {
                var detected = gesture && gesture.gestures && gesture.gestures.length > 0 && this._highlightedElement != undefined;
                return detected;
            };

            /**
            * Execute click on element.
            * @param clickableElement JQuery element.
            */
            Navigate.prototype.ExecuteClick = function (clickableElement) {
                // Show animation
                Core.Pointer.Default().ScreenTap();

                // Execute click
                clickableElement[0].click();
            };
            return Navigate;
        })();
        Motion.Navigate = Navigate;
    })(Diploma.Motion || (Diploma.Motion = {}));
    var Motion = Diploma.Motion;
})(Diploma || (Diploma = {}));
//# sourceMappingURL=Navigate.js.map
